!-----------------------
! madgraph - a Feynman Diagram package by Tim Stelzer and Bill Long 
! (c) 1993
!
! Filename: writesub.f
!-----------------------
 
      subroutine writesub(ngraphs,nexternal,nqed,nqcd)
!***************************************************************************
!     writes out the subroutines
!***************************************************************************
      implicit none

! Arguments

      integer ngraphs,nqed,nqcd,nexternal


! Local Variables

!      character*75 buff
!      character*20 name
      character*120 buff
      character*80 name
      character*3 temp
      integer i,jchar,ishift,nlength


! Global Variables

      integer           neigen
      common /to_color/ neigen

      integer       nwf,wnum(999)
      common/toopt/ nwf,wnum

!      character*15 gname
      character*80 gname
      integer iname
      common/to_name/iname,gname
      character*60 proc
      integer iproc
      common/to_write/iproc,proc

!-----------
! Begin Code
!-----------
      ishift = iname
      nlength = ishift
      open(unit=92,file=gname(1:iname)//'.f',status='unknown')

      name = gname(1:iname)
      call upper_case(name)

      print*,'Writing function ',name(1:iname) ,
     &     ' in file ',GNAME(1:iname)//'.f.'

      call writesum

      buff = 'REAL*8 FUNCTION '
      jchar = 17
      buff(jchar:jchar+ishift) = name(1:iname)
      jchar = jchar+ishift
      ishift= 3
      buff(jchar:jchar+ishift) = '(P1'
      jchar =jchar+ishift
      ishift = 4
      do i=2,nexternal
         write(buff(jchar:jchar+ishift),20) i
         jchar=jchar+ishift
      enddo
      buff(jchar:jchar+5)= ',NHEL)'
      write(92,'(6x,a)') buff(1:jchar+5)

! write comments

      write(92,5) ' '
      write(92,5) 'FUNCTION GENERATED BY MADGRAPH'
      write(92,5) 'RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS'
      write(92,5) 'FOR THE POINT IN PHASE SPACE P1,P2,P3,P4,...'
      write(92,5) 'AND HELICITY NHEL(1),NHEL(2),....'
      write(92,5) ' '
      write(92,5) 'FOR PROCESS '//proc(1:iproc)
      write(92,5) ' '

      write(92,10) 'IMPLICIT NONE'

! write parameters

      write(92,5) ' '
      write(92,5) 'CONSTANTS'
      write(92,5) ' '

      buff = 'INTEGER    NGRAPHS,    NEIGEN,    NEXTERNAL'
      write(92,10) buff(1:50)
      buff = 'PARAMETER (NGRAPHS=???,NEIGEN=???,NEXTERNAL=?)'
      write(buff(20:22),'(i3)') ngraphs
      write(buff(31:33),'(i3)') neigen
      write(buff(45:45),'(i1)') nexternal
      write(92,10) buff(1:50)
      write(92,10) 'REAL*8     ZERO'
      write(92,10) 'PARAMETER (ZERO=0D0)'

! write arguement declarations

      write(92,5) ' '
      write(92,5) 'ARGUMENTS '
      write(92,5) ' '

      buff = 'REAL*8 P1(0:3)'
      jchar= 15
      ishift = 8
      do i=2,nexternal
         write(buff(jchar:jchar+ishift),30) i
         jchar=jchar+ishift
      enddo
      write(92,10) buff
      buff = 'INTEGER NHEL(NEXTERNAL)'
      write(92,10) buff


! write local declarations

      write(92,5) ' '
      write(92,5) 'LOCAL VARIABLES '
      write(92,5) ' '

      write(92,10) 'INTEGER I,J'
      write(92,10) 'REAL*8 EIGEN_VAL(NEIGEN), EIGEN_VEC(NGRAPHS,NEIGEN)'
      write(92,10) 'COMPLEX*16 ZTEMP'
      write(92,10) 'COMPLEX*16 AMP(NGRAPHS)'
      buff = 'COMPLEX*16 W???(6), W???(6), W???(6), W???(6), W???(6)'
      jchar = 13
      ishift= 9
      do i=1,nwf
         if (mod(i,5) .eq. 1 .and. i .ne. 1) then
            write(92,10) buff(1:60)
            jchar = 13
         endif
         call makestringamp(i,temp)
         if (i .lt. 10) then
            buff(jchar:jchar)=temp(1:1)
            buff(jchar+1:jchar+3)='(6)'
            buff(jchar+4:jchar+5)='  '
         else if (i .lt. 100) then
            buff(jchar:jchar+1)=temp(1:2)
            buff(jchar+2:jchar+4)='(6)'
            buff(jchar+5:jchar+5)=' '
         else if (i .lt. 1000) then
            buff(jchar:jchar+2)=temp(1:3)
            buff(jchar+3:jchar+5)='(6)'
         endif
         jchar = jchar+ishift
      enddo
      write(92,10) buff(1:jchar-4)


! write global declarations

      write(92,5) ' '
      write(92,5) 'GLOBAL VARIABLES'
      write(92,5) ' '

      if (nqed .ne. 0) then
         write(92,10) 'REAL*8         GW, GWWA, GWWZ'
         write(92,10) 'COMMON /COUP1/ GW, GWWA, GWWZ'
         write(92,10) 'REAL*8         GAL(2),GAU(2),GAD(2),GWF(2)'
         write(92,10) 'COMMON /COUP2A/GAL,   GAU,   GAD,   GWF'
         write(92,10) 'REAL*8         GZN(2),GZL(2),GZU(2),GZD(2),G1(2)'
         write(92,10) 'COMMON /COUP2B/GZN,   GZL,   GZU,   GZD,   G1'
         write(92,10) 'REAL*8         GWWH,GZZH,GHHH,GWWHH,GZZHH,GHHHH'
         write(92,10) 'COMMON /COUP3/ GWWH,GZZH,GHHH,GWWHH,GZZHH,GHHHH'
         write(92,10) 'COMPLEX*16     GH(2,12)'
         write(92,10) 'COMMON /COUP4/ GH'
         write(92,10) 'REAL*8         WMASS,WWIDTH,ZMASS,ZWIDTH'
         write(92,10) 'COMMON /VMASS1/WMASS,WWIDTH,ZMASS,ZWIDTH'
         write(92,10) 'REAL*8         AMASS,AWIDTH,HMASS,HWIDTH'
         write(92,10) 'COMMON /VMASS2/AMASS,AWIDTH,HMASS,HWIDTH'
      endif
      if (nqcd .ne. 0) then
         write(92,10) 'REAL*8           GG(2), G'
         write(92,10) 'COMMON /COUPQCD/ GG,    G'
      endif
      write(92,10) 'REAL*8            FMASS(12), FWIDTH(12)'
      write(92,10) 'COMMON /FERMIONS/ FMASS,     FWIDTH'


      write(92,5) ' '
      write(92,5) 'COLOR DATA'
      write(92,5) ' '
      
      do while (.true.)
         read(99,'(a)',end=99) buff
         write(92,'(a)') buff
      enddo
 99   continue

      write(92,5) '----------'
      write(92,5) 'BEGIN CODE'
      write(92,5) '----------'

      do while (.true.)
         read(91,'(a)',end=999) buff
         write(92,'(a)') buff
      enddo
 999  continue

      buff(1:nlength) = name(1:nlength)
      buff(nlength+1:nlength+8) = ' = 0.D0'
      write(92,10) buff(1:nlength+8)
      write(92,10) 'DO I = 1, NEIGEN'
      write(92,10) '    ZTEMP = (0.D0,0.D0)'
      write(92,10) '    DO J = 1, NGRAPHS'
      write(92,10) '        ZTEMP = ZTEMP + EIGEN_VEC(J,I)*AMP(J)'
      write(92,10) '    ENDDO'
      buff(1:4) = '    '
      buff(5:nlength+5) = name(1:nlength)
      buff(nlength+6:nlength+6) = '='
      buff(nlength+7:2*nlength+7) = name(1:nlength)
      buff(2*nlength+7:2*nlength+39)=
     &     '+ZTEMP*EIGEN_VAL(I)*CONJG(ZTEMP)'
      write(92,10) buff(1:2*nlength+39)
      write(92,10) 'ENDDO'
      buff(1:46)='CALL GAUGECHECK(AMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,'
      buff(47:61)='NGRAPHS,NEIGEN)'
      write(92,15) buff(1:61)
      write(92,10) 'END'

      close(92)

 5    format('C ',A)
 10   format(6X,A)
 15   format('C',6X,A)
 20   format(', P',I1)
 30   format(',P',I1,'(0:3)')
      end

 
      subroutine writesum
!***************************************************************************
!     writes out the subroutine
!***************************************************************************
      implicit none

! Constants

      integer    maxlines
      parameter (maxlines=9)

! Local Variables

!      character*75 buff,fname
!      character*20 name
      character*120 buff,fname
      character*80 name
      integer i,jchar,ishift,nlength,j,flen,nexternal
      integer nhel(maxlines,3**maxlines),step(maxlines),ihel,iden

! Global Variables

      integer        iline(-maxlines:maxlines)
      common/to_proc/iline

!      character*15 gname
      character*80 gname
      integer iname
      common/to_name/iname,gname
      integer         nincoming
      common/to_proc2/nincoming
      character*60 proc
      integer iproc
      common/to_write/iproc,proc

!-----------
! Begin Code
!-----------
      nexternal=iline(0)
      iden=1
      do i=1,nexternal
         if (abs(iline(i)) .eq. 23) then
            step(i) = 1                        !Massive Vector Boson
            if (i .le. nincoming) iden=iden*3 
         elseif (abs(iline(i)) .eq. 24) then 
            step(i) = 1                        !Massive Vector Boson
            if (i .le. nincoming) iden=iden*3 
         elseif (abs(iline(i)) .eq. 25) then 
            step(i) = 3                        !Scalar
            if (i .le. nincoming) iden=iden*1 
         else
            step(i) = 2
            if (i .le. nincoming) iden=iden*2 
         endif
      enddo
      ishift = iname
      nlength = ishift

      name = gname(1:iname)
      call upper_case(name)

      call sethel(nhel,step,nexternal,ihel)

      buff = 'REAL*8 FUNCTION S'
      jchar = 18
      buff(jchar:jchar+ishift) = name(1:iname)
      jchar = jchar+ishift
      ishift= 3
      buff(jchar:jchar+ishift) = '(P1'
      jchar =jchar+ishift
      ishift = 4
      do i=2,nexternal
         write(buff(jchar:jchar+ishift),20) i
         jchar=jchar+ishift
      enddo
      buff(jchar:jchar)= ')'
      write(92,10) buff(1:jchar)
      FNAME= buff(18:jchar)
      FNAME(JCHAR-17:JCHAR-17+13)=',NHEL(1,IHEL))'
      FLEN = jchar-17+13

! write comments

      write(92,5) ' '
      write(92,5) 'FUNCTION GENERATED BY MADGRAPH'
      write(92,5) 'RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS'
      write(92,5) 'AND HELICITIES'
      write(92,5) 'FOR THE POINT IN PHASE SPACE P1,P2,P3,P4,...'
      write(92,5) ' '
      write(92,5) 'FOR PROCESS '//proc(1:iproc)
      write(92,5) ' '

      write(92,10) 'IMPLICIT NONE'

! write parameters

      write(92,5) ' '
      write(92,5) 'CONSTANTS'
      write(92,5) ' '
      buff = 'INTEGER    NEXTERNAL,   NCOMB'
      write(92,10) buff(1:50)
      buff = 'PARAMETER (NEXTERNAL=?, NCOMB=???)'
      write(buff(22:22),'(i1)') nexternal
      write(buff(31:33),'(i3)') ihel
      write(92,10) buff(1:34)

      write(92,5) ' '
      write(92,5) 'ARGUMENTS '
      write(92,5) ' '
      buff = 'REAL*8 P1(0:3)'
      jchar= 15
      ishift = 8
      do i=2,nexternal
         write(buff(jchar:jchar+ishift),30) i
         jchar=jchar+ishift
      enddo
      write(92,10) buff

      write(92,5) ' '
      write(92,5) 'LOCAL VARIABLES '
      write(92,5) ' '
      buff = 'INTEGER NHEL(NEXTERNAL,NCOMB),NTRY'
      write(92,10) buff
      write(92,10) 'REAL*8 T'
      buff = 'REAL*8 '
      buff(8:7+iname)=name(1:iname)
      write(92,10) buff
      write(92,10) 'INTEGER IHEL'
      write(92,10) 'LOGICAL GOODHEL(NCOMB)'
      write(92,10) 'DATA GOODHEL/NCOMB*.FALSE./'
      write(92,10) 'DATA NTRY/0/'
      BUFF = 'DATA (NHEL(IHEL,???),IHEL=1,?) /'
      write(buff(29:29),'(i1)') nexternal
      do i=1,ihel
         write(buff(17:19),'(i3)') i
         jchar=33
         ishift = 4
         do j=1,nexternal
            write(buff(jchar:jchar+ishift),'(I3,a)') nhel(j,i),','
            jchar=jchar+ishift
         enddo
         jchar=jchar-1
         write(buff(jchar:jchar),'(a1)') '/'
         write(92,10) buff(1:jchar)
      enddo
      write(92,5) '----------'
      write(92,5) 'BEGIN CODE'
      write(92,5) '----------'
      buff(1:1)='S'
      buff(2:iname+1) = name(1:iname)
      buff(iname+2:iname+7) = ' = 0d0'
      write(92,10) buff(1:iname+7)
      write(92,10) 'NTRY=NTRY+1'
      write(92,10) 'DO IHEL=1,NCOMB'
      write(92,10) '    IF (GOODHEL(IHEL) .OR. NTRY .LT. 10) THEN'
      buff(1:8) = '          '
      buff(8:9)= 'T='
      buff(10:10+flen) = fname(1:flen)  
      write(92,10) buff(1:10+flen)
      buff(1:8)='       S'
      jchar=9
      buff(jchar:jchar+iname-1) = name(1:iname)
      jchar=jchar+iname
      buff(jchar:jchar+3) = ' = S'
      jchar=jchar+4
      buff(jchar:jchar+iname-1) = name(1:iname)
      jchar=jchar+iname
      buff(jchar:jchar+3) = ' + T'
      write(92,10) buff(1:jchar+3)
      buff = '        IF (T .GT. 0D0 .AND. .NOT. GOODHEL(IHEL)) THEN'
      write(92,10) buff(1:54)
      write(92,10) '            GOODHEL(IHEL)=.TRUE.'
      write(92,10) '            WRITE(*,*) IHEL,T'
      write(92,10) '        ENDIF'
      write(92,10) '    ENDIF'
      write(92,10) 'ENDDO'
      buff(1:1) = 'S'
      jchar=2
      buff(jchar:jchar+iname-1) = name(1:iname)
      jchar=jchar+iname
      buff(jchar:jchar+3) = ' = S'
      jchar=jchar+4
      buff(jchar:jchar+iname-1) = name(1:iname)
      jchar=jchar+iname
      buff(jchar:jchar+2) = ' / '
      jchar=jchar+3
      write(buff(jchar:jchar+1),'(i2)') iden
      jchar=jchar+2
      buff(jchar:jchar+2)='D0'
      write(92,10) buff(1:jchar+2)
      write(92,10) 'END'
      write(92,10) ' '
      write(92,10) ' '

 5    format('C ',A)
 10   format(6X,A)
 15   format('C',6X,A)
 20   format(', P',I1)
 30   format(',P',I1,'(0:3)')
      end


      subroutine writesub_f90(ngraphs,nexternal,nqed,nqcd)
!***************************************************************************
!     writes out the subroutine for Fortran 90 
!***************************************************************************
      implicit none

! Arguments

      integer ngraphs,nqed,nqcd,nexternal

! Local Variables

!      character*75 buff
!      character*20 name
      character*120 buff
      character*80 name
      character*3 temp
      integer i,j,jchar,ishift,nlength

! Global Variables

      integer           neigen
      common /to_color/ neigen

      integer       nwf,wnum(999)
      common/toopt/ nwf,wnum

!      character*15 gname
      character*80 gname
      integer iname
      common/to_name/iname,gname
      character*60 proc
      integer iproc
      common/to_write/iproc,proc

      integer    maxlines
      parameter (maxlines=9)

      integer        iline(-maxlines:maxlines)
      common/to_proc/iline
      integer         nincoming
      common/to_proc2/nincoming

      integer nhel(maxlines,3**maxlines),step(maxlines),ihel,iden

!-----------
! Begin Code
!-----------
      ishift = iname
      nlength = ishift
      open(unit=92,file=gname(1:iname)//'.f',status='unknown')

      name = gname(1:iname)
      call lower_case(name)

      print*,'Writing function ',name(1:iname) ,
     &     ' in file ',gname(1:iname)//'.f.'

! Header
      write(92, 5) 'WHIZARD interface for Madgraph'
      write(92, 5)
      write(92, 5) 'Automatically generated file, do not edit'
      write(92, 5)

! Constants module 
      write(92,10) 'module '//trim(name)//'_const'
      write(92,10)
      write(92,10) '  use kinds, only: D=>default  !NODEP!'
      write(92,10)
      write(92,10) '  implicit none'
      write(92,10) '  public'
      write(92,10)

      write(92,11) '  integer,parameter :: ngraphs   = ',ngraphs
      write(92,11) '  integer,parameter :: neigen    = ',neigen
      write(92,11) '  integer,parameter :: nexternal = ',nexternal
      write(92,10) '  real(D),parameter :: zero = 0.0_D'
      write(92,10)
      write(92,10) 
     &'  real(D) :: gw, gwwa, gwwz                   ! /coup1/'
      write(92,10) 
     &'  real(D), dimension(2) :: gal,gau,gad,gwf    ! /coup2a/'
      write(92,10) 
     &'  real(D), dimension(2) :: gzn,gzl,gzu,gzd,g1 ! /coup2b/'
      write(92,10) 
     &'  real(D) :: gwwh,gzzh,ghhh,gwwhh,gzzhh,ghhhh ! /coup3/'
      write(92,10) 
     &'  complex(D), dimension(2,12) :: gchf         ! /coup4/'
      write(92,10) 
     &'  real(D) :: wmass,wwidth,zmass,zwidth        ! /vmass1/'
      write(92,10) 
     &'  real(D) :: amass,awidth,hmass,hwidth        ! /vmass2/'
      write(92,10) 
     &'  real(D), dimension(12) :: fmass, fwidth     ! /fermions/'
      write(92,10) 
     &'  real(D) :: gg(2), g                         ! /coupqcd/'
      write(92,10)
      write(92,10) '  save'
      write(92,10)
      write(92,10) 'end module '//trim(name)//'_const'
      write(92,10)
      write(92,10)


! Driver module

      write(92, 5) 'Driver module'
      write(92, 5) 'Process: '//trim(proc)
      write(92, 5)

      write(92,10) 'module '//trim(name)
      write(92,10)
      write(92,10) '  use kinds, only: D=>default !NODEP!'
      write(92,10) '  use parameters'
      write(92,10)
      write(92,10) '  use '//trim(name)//'_const !NODEP!'
      write(92,10)
    
      write(92,10) '  implicit none'
      write(92,10) '  private'

      write(92,10)
      write(92,10) "  public :: scatter_diagonal_nonzero"
      write(92,10) "  public :: number_particles, "//
     &     "number_particles_in, number_particles_out"
      write(92,10) "  public :: number_spin_states, "//
     &     "number_spin_states_in, number_spin_states_out"
      write(92,10) "  public :: spin_states, "//
     &     "spin_states_in, spin_states_out"
      write(92,10) "  public :: number_flavor_states, "//
     &     "number_flavor_states_in, number_flavor_states_out"
      write(92,10) "  public :: flavor_states, "//
     &     "flavor_states_in, flavor_states_out"
      write(92,10) "  public :: number_flavor_zeros, "//
     &     "number_flavor_zeros_in, number_flavor_zeros_out"
      write(92,10) "  public :: flavor_zeros, "//
     &     "flavor_zeros_in, flavor_zeros_out"
      write(92,10) "  public :: create, reset, destroy"
      write(92,10)

c ! Old interface
c        write(92,10)
c        write(92,10) "  public :: n_in, n_out, pdg_code"
c        write(92,10) "  public :: allow_helicities"
c        write(92,10) "  public :: create, destroy"
c        write(92,10) "  public :: set_const, sqme"
c        write(92,10)

      nexternal=iline(0)
      iden=1
      do i=1,nexternal
         if (abs(iline(i)) .eq. 23) then
            step(i) = 1                        !Massive Vector Boson
            if (i .le. nincoming) iden=iden*3 
         elseif (abs(iline(i)) .eq. 24) then 
            step(i) = 1                        !Massive Vector Boson
            if (i .le. nincoming) iden=iden*3 
         elseif (abs(iline(i)) .eq. 25) then 
            step(i) = 3                        !Scalar
            if (i .le. nincoming) iden=iden*1 
         else
            step(i) = 2
            if (i .le. nincoming) iden=iden*2 
         endif
      enddo

      call sethel(nhel,step,nexternal,ihel)

      write(92,5) ' '
      write(92,5) 'Local Variables '
      write(92,5) ' '

      write(92,10)'    integer, parameter :: SAMPLE = 10, REPEAT = 5'
      write(92,11)'    integer, parameter :: ncomb =', ihel
!      write(92,11)'    integer, parameter :: nexternal =', nexternal
      write(92,10)'    integer, dimension(nexternal,ncomb):: nhel'

! write data tables

      write(92,5) ' '
      write(92,5) 'Helicity combination tables'
      write(92,5) ' '

      buff = 'data nhel(1:?,???) /'
      write(buff(13:13),'(i1)') nexternal
      do i=1,ihel
         write(buff(15:17),'(i3)') i
         jchar=22
         ishift = 4
         do j=1,nexternal
            write(buff(jchar:jchar+ishift),'(i3,a)') nhel(j,i),','
            jchar=jchar+ishift
         enddo
         jchar=jchar-1
         write(buff(jchar:jchar),'(a1)') '/'
         write(92,10) '    '//buff(1:jchar)
      enddo

      write(92,10) 'contains'
      write(92,10)

! User-level routines
      call write_interface(nexternal, nhel, ihel, iden)

! Summed-over sqme
c       call writesum_f90

! write comments

      write(92,5)
      write(92,5) 'Function generated by MADGRAPH [modified *FP,WK*]'
      write(92,5) 'Returns amplitude squared summed/avg over colors'
      write(92,5) 'for the point in phase space p1,p2,p3,p4,...'
      write(92,5) 'and helicity nhel(1),nhel(2),....'
      write(92,5) ' '
      write(92,5) 'For process '//proc(1:iproc)
      write(92,5) ' '

! Polarized sqme
      buff = 'function '
      jchar = 10
      ishift = 8
      buff(jchar:jchar+ishift) = "sqme_pol"
      jchar = jchar+ishift
      ishift= 3
!       buff(jchar:jchar+ishift) = '(p1'
      buff(jchar:jchar+ishift) = '(pp'
      jchar =jchar+ishift
!       do i=2,nexternal
!          write(buff(jchar:jchar+ishift),20) i
!          jchar=jchar+ishift
!       enddo
      buff(jchar:jchar+5)= ',nhel)'
      write(92,10) '  '//buff(1:jchar+5)

!      write(92,10) '  implicit none'

! write parameters

!       write(92,5) ' '
!       write(92,5) 'Constants'
!       write(92,5) ' '

!      write(92,10) 'integer,parameter :: D = selected_real_kind(14,100)'
!      write(92,11) 'integer,parameter :: ngraphs   = ',ngraphs
!      write(92,11) 'integer,parameter :: neigen    = ',neigen
!      write(92,11) 'integer,parameter :: nexternal = ',nexternal
!      write(92,10) 'real(D),parameter :: zero = 0.0_D'

! write argument declarations

      write(92,5) ' '
      write(92,5) 'Arguments '
      write(92,5) ' '

      write(92,10) '    real(D) :: sqme_pol'
      write(92,10) 
     &     '    real(D),dimension(0:3,nexternal),intent(in) :: pp'
!       buff =       'real(D),dimension(0:3),intent(in) :: p1'
!       jchar= 40
!       ishift = 3
!       do i=2,nexternal
!          write(buff(jchar:jchar+ishift),20) i
!          jchar=jchar+ishift
!       enddo
!       write(92,10) trim(buff)
      write(92,10) 
     &     '    integer,dimension(nexternal),    intent(in) :: nhel'

! write local declarations

      write(92,5) ' '
      write(92,5) 'Local Variables '
      write(92,5) ' '

      write(92,10) '    real(D) :: s'
      write(92,10)
      write(92,10) '    complex(D), dimension(2,12) :: gh          '

      write(92,5) ' '
      write(92,10,advance='no') '    real(D), dimension(0:3) :: p1'
      do i=2, nexternal
         write(92,'(A,I1)',advance='no') ',p', i
      end do
      write(92,5)

      write(92,10) '    integer                           :: i'
      write(92,10) '    real(D),dimension(neigen)         :: eigen_val' 
      write(92,10) '    real(D),dimension(ngraphs,neigen) :: eigen_vec'
      write(92,10) '    complex(D)                        :: ztemp'
      write(92,10) '    complex(D),dimension(ngraphs)     :: amp'
      buff = 'complex(D),dimension(6) :: w???, w???, w???, w???, w???'
      jchar = 29
      ishift= 6
      do i=1,nwf
         if (mod(i,5) .eq. 1 .and. i .ne. 1) then
            write(92,10) '    '//buff(1:60)
            jchar = 29
         endif
         call makestringamp(i,temp)
         if (i .lt. 10) then
            buff(jchar:jchar)=temp(1:1)
            buff(jchar+1:jchar+2)='  '
         else if (i .lt. 100) then
            buff(jchar:jchar+1)=temp(1:2)
            buff(jchar+2:jchar+2)=' '
         else if (i .lt. 1000) then
            buff(jchar:jchar+2)=temp(1:3)
         endif
         jchar = jchar+ishift
      enddo
      write(92,10) '    '//buff(1:jchar-4)


! write global declarations

!     write(92,5) ' '
!     write(92,5) 'Global Variables'
!     write(92,5) ' '
!
!     if (nqed .ne. 0) then
!        write(92,10) 'real(D)              :: gw, gwwa, gwwz'
!        write(92,10) 'common /coup1/          gw, gwwa, gwwz'
!        write(92,10) 'real(D),dimension(2) :: gal,gau,gad,gwf'
!        write(92,10) 'common /coup2a/         gal,gau,gad,gwf'
!        write(92,10) 'real(D),dimension(2) :: gzn,gzl,gzu,gzd,g1'
!        write(92,10) 'common /coup2b/         gzn,gzl,gzu,gzd,g1'
!        write(92,10) 'real(D)     :: gwwh,gzzh,ghhh,gwwhh,gzzhh,ghhhh'
!        write(92,10) 'common /coup3/ gwwh,gzzh,ghhh,gwwhh,gzzhh,ghhhh'
!        write(92,10) 'complex(D),dimension(2,12) :: gh'
!        write(92,10) 'common /coup4/                gh'
!        write(92,10) 'real(D)     :: wmass,wwidth,zmass,zwidth'
!        write(92,10) 'common /vmass1/wmass,wwidth,zmass,zwidth'
!        write(92,10) 'real(D)     :: amass,awidth,hmass,hwidth'
!        write(92,10) 'common /vmass2/amass,awidth,hmass,hwidth'
!     endif
!     if (nqcd .ne. 0) then
!        write(92,10) 'real(D)       :: gg(2), g'
!        write(92,10) 'common /coupqcd/ gg,    g'
!     endif
!     write(92,10) 'real(D),dimension(12) :: fmass,fwidth'
!     write(92,10) 'common /fermions/        fmass,fwidth'

      write(92,5) ' '
      write(92,5) 'Color Data'
      write(92,5) ' '

      do while (.true.)
         read(99,'(a)',end=99) buff
         call lower_case(buff)
         buff(52:52) = 'e'
         buff(56:58) = '_D/'
         write(92,'(a)') '    '//buff
      enddo
 99   continue

      write(92,5) '----------'
      write(92,5) 'Begin Code'
      write(92,5) '----------'

! *WK: Copy momenta to local variables
      do i=1,nexternal
         write(92,'(6x,A,I1,A,I1,A)') '    p', i, ' = pp(:,', i, ')'
      end do
      write(92,10)

! *WK: This seems to be inconsistent
      write(92,10) "    gh     = gchf"
      write(92,10)

! Write HELAS calls
      do while (.true.)
         read(91,'(a)',end=999) buff
         call lower_case(buff)
         if (buff(6:6)==' ') then
            write(92,'(a)') '    '//buff
         else
            write(92,'(a)') buff
         end if
      enddo
 999  continue

      buff(1:9) = 's = 0.0_D'
      write(92,10) '    '//buff(1:9)
      write(92,10) '    do i = 1, neigen'
      write(92,10) '        ztemp = sum(eigen_vec(:,i)*amp(:))'
      buff(1:4) = '    '
      buff(5:10) = 's = s '
      buff(11:43)=
     &     '+ ztemp*eigen_val(i)*conjg(ztemp)'
      write(92,10) '    '//buff(1:43)
      write(92,10) '    enddo'
      buff(1:46)='call gaugecheck(amp,ztemp,eigen_vec,eigen_val,'
      buff(47:61)='ngraphs,neigen)'
      write(92,15) '    '//buff(1:61)
      write(92,10) "    sqme_pol = s"
      write(92,10) "  end function sqme_pol"
      write(92,10)

! *WK: module wrapper
      write(92, 10) 'end module '//trim(name)
      close(92)

 5    format('! ',a)
 10   format(6x,a)
 11   format(6x,a,i5)
 15   format('!',6x,a)
 20   format(',p',i1)
      end


c        subroutine writesum_f90
c  !***************************************************************************
c  !     writes out the subroutine - f90 version
c  !***************************************************************************
c        implicit none

c  ! Constants

c        integer    maxlines
c        parameter (maxlines=9)

c  ! Local Variables

c  !      character*75 buff,fname
c        character*120 buff,fname
c        character*30 plist
c  !      character*20 name
c        character*80 name
c  !      character*21 sname
c        character*81 sname
c        integer isname,iplist
c        integer i,jchar,ishift,j,flen,nexternal
c        integer nhel(maxlines,3**maxlines),step(maxlines),ihel,iden

c  ! Global Variables

c        integer        iline(-maxlines:maxlines)
c        common/to_proc/iline

c  !      character*15 gname
c        character*80 gname
c        integer iname
c        common/to_name/iname,gname
c        integer         nincoming
c        common/to_proc2/nincoming
c        character*60 proc
c        integer iproc
c        common/to_write/iproc,proc
c  ! *WK
c        logical prec
c        common/precision/prec

c  !-----------
c  ! Begin Code
c  !-----------

c        nexternal=iline(0)
c        iden=1
c        do i=1,nexternal
c           if (abs(iline(i)) .eq. 23) then
c              step(i) = 1                        !Massive Vector Boson
c              if (i .le. nincoming) iden=iden*3 
c           elseif (abs(iline(i)) .eq. 24) then 
c              step(i) = 1                        !Massive Vector Boson
c              if (i .le. nincoming) iden=iden*3 
c           elseif (abs(iline(i)) .eq. 25) then 
c              step(i) = 3                        !Scalar
c              if (i .le. nincoming) iden=iden*1 
c           else
c              step(i) = 2
c              if (i .le. nincoming) iden=iden*2 
c           endif
c        enddo

c        name = gname(1:iname)
c        call lower_case(name)
c        sname = "sqme_mad"
c        isname = 8
c  !      plist(1:2) = 'p1'
c  !       jchar = 3
c  !       do i=2,nexternal
c  !          write(plist(jchar:jchar+3),20) i
c  !          jchar=jchar+3
c  !       enddo
c  !       iplist = 3*nexternal-1
c        plist = 'pp'
c        jchar = 3
c        iplist = 2

c        call sethel(nhel,step,nexternal,ihel)

c  ! write comments

c        write(92,5) ' '
c        write(92,5) 'Function generated by MADGRAPH.'
c        write(92,5) 'Returns amplitude squared summed/avg over colors'
c        write(92,5) 'and (optionally) helicities'
c        write(92,5) 'for the point in phase space p1,p2,p3,p4,...'
c        write(92,5) ' '
c        write(92,5) 'For process '//proc(1:iproc)
c        write(92,5) ' '

c        buff = 'function '//sname(:isname)//'('//plist(:iplist)//         & 
c       &     ',khel)'
c        jchar = 9+isname+iplist
c        write(92,10) '  '//buff(1:jchar+8)

c        fname= buff(11:jchar)
c        fname(jchar-10:jchar-10+16)=',nhel(1:?,ihel))'
c        flen = jchar-10+16
c        write(fname(flen-8:flen-8),'(i1)') nexternal

c  ! write parameters

c        write(92,5) ' '
c        write(92,5) 'Constants'
c        write(92,5) ' '

c  !      write(92,10) 'integer,parameter :: D = selected_real_kind(14,100)'
c  !       write(92,11) 'integer,parameter :: nexternal = ',nexternal
c  !       write(92,11) '    integer,parameter :: ncomb     = ',ihel

c  ! write argument declarations

c        write(92,5) ' '
c        write(92,5) 'Arguments '
c        write(92,5) ' '

c        write(92,10) '    real(D) :: '//sname(1:isname)
c        write(92,10) 
c       &     '    real(D), dimension(0:3,nexternal), intent(in) :: pp'
c  !       buff =       'real(D),dimension(0:3),intent(in) :: '
c  !       buff(38:) = plist(:iplist)
c  !       write(92,10) trim(buff)
c  c       write(92,10) '    integer, optional, intent(in) :: khel'
c        write(92,10)'    integer, dimension(nexternal), intent(in) :: nhel'

c  ! write external function interface

c  !       write(92,5)  ' '
c  !       write(92,5)  'External Function'
c  !       write(92,5)  ' '

c  !       write(92,10) 'interface'
c  !       write(92,10) ' function '//name(:iname)//'('//
c  !      &                            plist(:iplist)//',nhel)'
c  ! ! * The declaration needs to be repeated here
c  !       write(92,10) '  use kinds, only: D=>double'
c  !       write(92,11) '  integer,parameter :: nexternal = ',nexternal
c  !       write(92,10) '  real(D)                           :: '//
c  !      &                            name(:iname)
c  !       write(92,10) '  real(D),dimension(0:3),intent(in) :: '//
c  !      &                            plist(:iplist)
c  !       write(92,10) '  integer,dimension(nexternal),intent(in) :: nhel'
c  !       write(92,10) ' end function '
c  !       write(92,10) 'end interface'

c  ! write local declarations

c        write(92,5) ' '
c        write(92,5) 'Local Variables '
c        write(92,5) ' '

c        write(92,10)'    integer                           :: ihel,ntry'
c        write(92,10)'    integer,dimension(nexternal,ncomb):: nhel'
c        write(92,10)'    logical,dimension(ncomb)          :: goodhel'

c        write(92,10)'    real(D)                           :: t'

c  ! write data tables

c        write(92,5) ' '
c        write(92,5) 'Helicity combination tables'
c        write(92,5) ' '

c        write(92,10) '    data goodhel/ncomb*.false./'
c        write(92,10) '    data ntry/0/'
c        buff = 'data nhel(1:?,???) /'
c        write(buff(13:13),'(i1)') nexternal
c        do i=1,ihel
c           write(buff(15:17),'(i3)') i
c           jchar=22
c           ishift = 4
c           do j=1,nexternal
c              write(buff(jchar:jchar+ishift),'(i3,a)') nhel(j,i),','
c              jchar=jchar+ishift
c           enddo
c           jchar=jchar-1
c           write(buff(jchar:jchar),'(a1)') '/'
c           write(92,10) '    '//buff(1:jchar)
c        enddo

c        write(92,5) '----------'
c        write(92,5) 'Begin Code'
c        write(92,5) '----------'
c        write(92,10) '    '//sname(1:isname)//' = 0'
c        write(92,10) '    if (present(khel)) then'
c        write(92,10) '       if (khel==1) ntry=ntry+1'
c        write(92,10) '       if (goodhel(khel) .or. ntry < 10) then'
c        write(92,12) '          t=sqme_pol'//
c       &     "(pp,nhel(1:", nexternal, ",khel))"
c        write(92,10) 
c       &'          '//sname(1:isname)//' = '//sname(1:isname)//' + t'
c        write(92,10) 
c       &'          if (t > 0.0_D .and. .not. goodhel(khel)) then'
c        write(92,10) '             goodhel(khel)=.true.'
c  !      write(92,10) '            write(*,*) ihel,t'
c        write(92,10) '          end if'
c        write(92,10) '       end if'
c        write(92,10) '    else'
c        write(92,10) '       ntry=ntry+1'
c        write(92,10) '       do ihel=1,ncomb'
c        write(92,10) '          if (goodhel(ihel) .or. ntry < 10) then'
c        write(92,12) '             t=sqme_pol'//
c       &     "(pp,nhel(1:", nexternal, ",ihel))"
c        write(92,10) 
c       &'             '//sname(1:isname)//' = '//sname(1:isname)//' + t'
c        write(92,10) 
c       &'             if (t > 0.0_D .and. .not. goodhel(ihel)) then'
c        write(92,10) '                goodhel(ihel)=.true.'
c  !      write(92,10) '                write(*,*) ihel,t'
c        write(92,10) '             end if'
c        write(92,10) '          end if'
c        write(92,10) '       end do'
c        buff =        sname(1:isname)//' = '//sname(1:isname)//'/??.0_D'
c        jchar=2*isname + 5
c        write(buff(jchar:jchar+1),'(i2)') iden
c        write(92,10) '       '//buff(1:jchar+6)
c        write(92,10) '    end if'
c        write(92,10) '  end function '//trim(sname)
c        write(92,10) ' '
c        write(92,10) ' '


c   5    format('! ',a)
c   10   format(6x,a)
c   11   format(6x,a,i5)
c   12   format(6x,a,i1,a)
c   15   format('!',6x,a)
c   20   format(',p',i1)
c        end
      

      
      subroutine sethel(nhel,step,npart,ihel)
c************************************************************************
c     Sets up all possible helicity combinations in nhel(ipart,ihel)
c     given the number of particles, and the step size to be used
c     for each particle
c     The first state is always -1, the next is 0 or 1 depending onstep
c************************************************************************
      implicit none

!     Constants
      
      integer    maxlines
      parameter (maxlines=9)

!     Arguments
      
      integer nhel(maxlines,3**maxlines),step(maxlines),npart,ihel

!     Local

      integer ipart,iflip
      logical gotone

      ihel=1
      do ipart=1,npart
         nhel(ipart,ihel)=-1
      enddo
      gotone=.true.
      do while (gotone)
c         write(*,'(8I4)'),ihel,(nhel(ipart,ihel),ipart=1,npart)
         ihel=ihel+1
         do ipart=1,npart
            nhel(ipart,ihel)=nhel(ipart,ihel-1)
         enddo
         gotone = .false.
         iflip = npart
         do while(.not. gotone .and. iflip .gt. 0)
            nhel(iflip,ihel) = nhel(iflip,ihel)+step(iflip)
            if (nhel(iflip,ihel) .gt. 1) then
               nhel(iflip,ihel) = -1
               iflip =iflip-1
            else
               gotone=.true.
            endif
         enddo
      enddo
      ihel=ihel-1
      end


!-------------------------------------
      subroutine lower_case(string)
      implicit none

! Constants

      integer    char_a,              char_z
      parameter (char_a = ichar('A'), char_z = ichar('Z'))
      integer    lcshift
      parameter (lcshift = ichar('a') - ichar('A'))


! Argument

      character*(*) string

! Local Variable

      integer i

!-----------
! Begin Code
!-----------
      do i=1,len(string)
         if (ichar(string(i:i)) .ge. char_a .and.
     &       ichar(string(i:i)) .le. char_z) then
            string(i:i)=char(ichar(string(i:i))+lcshift)
         end if
      end do
      end

!-------------------------------------
      subroutine upper_case(string)
      implicit none

! Constants

      integer    char_a,              char_z
      parameter (char_a = ichar('a'), char_z = ichar('z'))
      integer    ucshift
      parameter (ucshift = ichar('A') - ichar('a'))

! Argument

      character*(*) string

! Local Variable

      integer i

!-----------
! Begin Code
!-----------
      do i=1,len(string)
         if (ichar(string(i:i)) .ge. char_a .and.
     &       ichar(string(i:i)) .le. char_z) then
            string(i:i)=char(ichar(string(i:i))+ucshift)
         end if
      end do
      end

!***************************************************************************
!     *WK: writes out interfacing subroutines
!***************************************************************************
      subroutine write_interface(nexternal, nhel, ihel, iden)

! Constants

      integer    maxlines
      parameter (maxlines=9)

! Arguments
      integer, intent(in) :: nexternal
      integer nhel(maxlines,3**maxlines),step(maxlines),ihel,iden

! Global Variables

      integer        iline(-maxlines:maxlines)
      common/to_proc/iline

!      character*15 gname
      character*80 gname
      integer iname
      common/to_name/iname,gname
      integer         nincoming
      common/to_proc2/nincoming

! Local variables
      integer :: i, code
!      character*20 name
      character*80 name

! Begin code
      name = gname(1:iname)
      call lower_case(name)

! Write service functions
      write(92,11) '  function number_particles () result (n)'
      write(92,11) '    integer :: n'
      write(92,11) '    n = ', nexternal
      write(92,11) '  end function number_particles'

      write(92,11) '  function number_particles_in () result (n)'
      write(92,11) '    integer :: n'
      write(92,11) '    n = ', nincoming
      write(92,11) '  end function number_particles_in'

      write(92,11) '  function number_particles_out () result (n)'
      write(92,11) '    integer :: n'
      write(92,11) '    n = ', nexternal - nincoming
      write(92,11) '  end function number_particles_out'
      write(92,10)

      if (mod(ihel,iden) /= 0) then
         print *, "Number of spin states (total)    =", ihel
         print *, "Number of spin states (incoming) =", iden
         stop "Mismatch in helicity counting"
      end if

      write(92,11) '  function number_spin_states () result (n)'
      write(92,11) '    integer :: n'
      write(92,44) '    n = ', ihel
      write(92,11) '  end function number_spin_states'

      write(92,11) '  function number_spin_states_in () result (n)'
      write(92,11) '    integer :: n'
      write(92,44) '    n = ', iden
      write(92,11) '  end function number_spin_states_in'

      write(92,11) '  function number_spin_states_out () result (n)'
      write(92,11) '    integer :: n'
      write(92,44) '    n = ', ihel / iden
      write(92,11) '  end function number_spin_states_out'
      write(92,10)

! Assume that the out-spin index varies faster than the in-index

      write(92,11) '  subroutine spin_states (a)'
      write(92,11) '    integer, dimension(:,:), intent(inout) :: a'
      write(92,11) '    a = nhel'
      write(92,11) '  end subroutine spin_states'

      write(92,11) '  subroutine spin_states_in (a)'
      write(92,11) '    integer, dimension(:,:), intent(inout) :: a'
      write(92,11) '    a = nhel(:number_particles_in(), '//
     &     '::number_spin_states_out())'
      write(92,11) '  end subroutine spin_states_in'

      write(92,11) '  subroutine spin_states_out (a)'
      write(92,11) '    integer, dimension(:,:), intent(inout) :: a'
      write(92,11) '    a = nhel(number_particles_in()+1:, '//
     &     ':number_spin_states_out())'
      write(92,11) '  end subroutine spin_states_out'
      write(92,10)


      write(92,11) '  function number_flavor_states () result (n)'
      write(92,11) '    integer :: n'
      write(92,11) '    n = 1'
      write(92,11) '  end function number_flavor_states'

      write(92,11) '  subroutine flavor_states (a)'
      write(92,11) '    integer, dimension(:,:), intent(inout) :: a'
      do i=1, nincoming
         code = -iline(i)
         if (abs(code)==9) then
            code = 21           ! fix gluon assignment
         else if (abs(code)==22 .or. abs(code)==23 .or. 
     &            abs(code)==25) then
            code = abs(code)    ! neutral bosons
         end if
         write(92,23) '    a(', i, ',1) =', code
      end do
      do i=nincoming+1, nexternal
         code = iline(i)
         if (abs(code)==9)  code = 21 ! fix gluon assignment
         write(92,23) '    a(', i, ',1) =', code
      end do
      write(92,11) '  end subroutine flavor_states'
      write(92,10)

      write(92,11) '  function number_flavor_states_in () result (n)'
      write(92,11) '    integer :: n'
      write(92,11) '    n = 1'
      write(92,11) '  end function number_flavor_states_in'

      write(92,11) '  subroutine flavor_states_in (a)'
      write(92,11) '    integer, dimension(:,:), intent(inout) :: a'
      do i=1, nincoming
         code = -iline(i)
         if (abs(code)==9) then
            code = 21           ! fix gluon assignment
         else if (abs(code)==22 .or. abs(code)==23 .or. 
     &            abs(code)==25) then
            code = abs(code)    ! neutral bosons
         end if
         write(92,23) '    a(', i, ',1) =', code
      end do
      write(92,11) '  end subroutine flavor_states_in'
      write(92,10)

      write(92,11) '  function number_flavor_states_out () result (n)'
      write(92,11) '    integer :: n'
      write(92,11) '    n = 1'
      write(92,11) '  end function number_flavor_states_out'

      write(92,11) '  subroutine flavor_states_out (a)'
      write(92,11) '    integer, dimension(:,:), intent(inout) :: a'
      do i=1, nexternal-nincoming
         code = iline(nincoming+i)
         if (abs(code)==9) code = 21   ! fix gluon assignment
         write(92,23) '    a(', i, ',1) =', code
      end do
      write(92,11) '  end subroutine flavor_states_out'
      write(92,10)

      write(92,11) '  function number_flavor_zeros () result (n)'
      write(92,11) '    integer :: n'
      write(92,11) '    n = 0'
      write(92,11) '  end function number_flavor_zeros'

      write(92,11) '  subroutine flavor_zeros (a)'
      write(92,11) '    integer, dimension(:,:), intent(inout) :: a'
      write(92,11) '    a = 0'
      write(92,11) '  end subroutine flavor_zeros'
      write(92,10)

      write(92,11) '  function number_flavor_zeros_in () result (n)'
      write(92,11) '    integer :: n'
      write(92,11) '    n = 0'
      write(92,11) '  end function number_flavor_zeros_in'

      write(92,11) '  subroutine flavor_zeros_in (a)'
      write(92,11) '    integer, dimension(:,:), intent(inout) :: a'
      write(92,11) '    a = 0'
      write(92,11) '  end subroutine flavor_zeros_in'
      write(92,10)

      write(92,11) '  function number_flavor_zeros_out () result (n)'
      write(92,11) '    integer :: n'
      write(92,11) '    n = 0'
      write(92,11) '  end function number_flavor_zeros_out'

      write(92,11) '  subroutine flavor_zeros_out (a)'
      write(92,11) '    integer, dimension(:,:), intent(inout) :: a'
      write(92,11) '    a = 0'
      write(92,11) '  end subroutine flavor_zeros_out'
      write(92,10)

      write(92,11) '  subroutine multiplicity (m)'
      write(92,11) '    integer, dimension(:), intent(inout) :: m'
      write(92,11) '    m = 1'
      write(92,11) '  end subroutine multiplicity'
      write(92,10)

c ! Old interface
c        write(92,11) '  function pdg_code (i)'
c        write(92,11) '    integer, intent(in) :: i'
c        write(92,11) '    integer :: pdg_code'
c        write(92,11) '    select case (i)'
c        do i=1, nincoming
c           code = -iline(i)
c           if (abs(code)==9) code = 21   ! fix gluon assignment
c           write(92,23) '    case(', i, ');  pdg_code =', code
c        end do
c        do i=nincoming+1, nexternal
c           code = iline(i)
c           if (abs(code)==9) code = 21   ! fix gluon assignment
c           write(92,23) '    case(', i, ');  pdg_code =', code
c        end do
c        write(92,11) '    case default;  pdg_code = 0'
c        write(92,11) '    end select'
c        write(92,11) '  end function pdg_code'
c        write(92,10)

c        write(92,10) '  function allow_helicities ()'
c        write(92,10) '    logical :: allow_helicities'
c        write(92,10) '    allow_helicities = .true.'
c        write(92,10) '  end function allow_helicities'
c        write(92,10)


c  ! Write service functions (old interface)

c        write(92,11) '  function n_in ()'
c        write(92,11) '    integer :: n_in'
c        write(92,11) '    n_in = ', nincoming
c        write(92,11) '  end function n_in'
c        write(92,10)

c        write(92,11) '  function n_out ()'
c        write(92,11) '    integer :: n_out'
c        write(92,11) '    n_out = ', nexternal-nincoming
c        write(92,11) '  end function n_out'
c        write(92,10)

c        write(92,11) '  function pdg_code (i)'
c        write(92,11) '    integer, intent(in) :: i'
c        write(92,11) '    integer :: pdg_code'
c        write(92,11) '    select case (i)'
c        do i=1, nincoming
c           code = -iline(i)
c           if (abs(code)==9) code = 21   ! fix gluon assignment
c           write(92,23) '    case(', i, ');  pdg_code =', code
c        end do
c        do i=nincoming+1, nexternal
c           code = iline(i)
c           if (abs(code)==9) code = 21   ! fix gluon assignment
c           write(92,23) '    case(', i, ');  pdg_code =', code
c        end do
c        write(92,11) '    case default;  pdg_code = 0'
c        write(92,11) '    end select'
c        write(92,11) '  end function pdg_code'
c        write(92,10)

c        write(92,10) '  function allow_helicities ()'
c        write(92,10) '    logical :: allow_helicities'
c        write(92,10) '    allow_helicities = .true.'
c        write(92,10) '  end function allow_helicities'
c        write(92,10)

! Write the constructor for the constant block
      write(92,10) "  subroutine create"
      write(92,10) "  end subroutine create"
      write(92,10)

      write(92,10) "  subroutine destroy"
      write(92,10) "  end subroutine destroy"
      write(92,10)

! Write the routine for setting constants
! This replaces the corresponding helas routines
c       write(92,10) "  subroutine set_const (par)"
      write(92,10) "  subroutine reset (par)"
      write(92,10) "    type(parameter_set), intent(in) :: par"
      write(92,10) "    real(D) :: ez, ey, v"
      write(92,10) "    ez = par%EE / par%SW / par%CW"
      write(92,10) "    ey = par%EE * par%SW / par%CW"
      write(92,10) "    gw     =  par%EE / par%SW"
      write(92,10) "    gwwa   =  par%EE"
      write(92,10) "    gwwz   =  par%EE * par%CW / par%SW"
      write(92,10) "    gal    =  par%EE"
      write(92,10) "    gau    = -par%EE * (2._D/3._D)"
      write(92,10) "    gad    =  par%EE * (1._D/3._D)"
      write(92,10) "    gwf(1) = -par%EE / par%SW / sqrt(2._D)"
      write(92,10) "    gwf(2) =  0"
      write(92,10) "    gzn(1) = -ez *  .5_D"
      write(92,10) "    gzn(2) =  0"
      write(92,10) "    gzl(1) = -ez *(-.5_D + par%SW**2)"
      write(92,10) "    gzl(2) = -ey"
      write(92,10) "    gzu(1) = -ez *( .5_D - (2._D/3._D)"
     &     //"*par%SW**2)"
      write(92,10) "    gzu(2) =  ey *            (2._D/3._D)"
      write(92,10) "    gzd(1) = -ez *(-.5_D + (1._D/3._D)"
     &     //"*par%SW**2)"
      write(92,10) "    gzd(2) = -ey *            (1._D/3._D)"
      write(92,10) "    g1     = 1"
      write(92,10) "    v      = 2 * par%MW * par%SW / par%EE "
      write(92,10) "    gwwh   =  (par%EE/par%SW)**2 * v / 2"
      write(92,10) "    gzzh   =  (par%EE/par%SW/par%CW)**2 * v / 2"
      write(92,10) "    ghhh   = -(par%mH)**2 / v * 3"
      write(92,10) "    gwwhh  =  (par%EE/par%SW)**2 / 2"
      write(92,10) "    gzzhh  =  (par%EE/par%SW/par%CW)**2 / 2"
      write(92,10) "    ghhhh  = -(par%mH/v)**2 * 3"
      write(92,10) "    fmass( 1) = par%Me"
      write(92,10) "    fmass( 2) = 0"
      write(92,10) "    fmass( 3) = 0"
      write(92,10) "    fmass( 4) = 0"
      write(92,10) "    fmass( 5) = par%Mm"
      write(92,10) "    fmass( 6) = 0"
      write(92,10) "    fmass( 7) = par%Mc"
      write(92,10) "    fmass( 8) = par%Ms"
      write(92,10) "    fmass( 9) = par%Mt"
      write(92,10) "    fmass(10) = 0"
      write(92,10) "    fmass(11) = par%Mtop"
      write(92,10) "    fmass(12) = par%Mb"
      write(92,10) "    fwidth( 1) = 0"
      write(92,10) "    fwidth( 2) = 0"
      write(92,10) "    fwidth( 3) = 0"
      write(92,10) "    fwidth( 4) = 0"
      write(92,10) "    fwidth( 5) = 0"
      write(92,10) "    fwidth( 6) = 0"
      write(92,10) "    fwidth( 7) = 0"
      write(92,10) "    fwidth( 8) = 0"
      write(92,10) "    fwidth( 9) = 0"
      write(92,10) "    fwidth(10) = 0"
      write(92,10) "    fwidth(11) = par%wtop"
      write(92,10) "    fwidth(12) = 0"
      write(92,10) "    gchf(1,:)  = (-ez / par%mZ / 2) * fmass"
      write(92,10) "    gchf(2,:) = gchf(1,:)"
      write(92,10) "    gg = -1"
      write(92,10) "    wmass = par%mW"
      write(92,10) "    zmass = par%mZ"
      write(92,10) "    amass = 0"
      write(92,10) "    hmass = par%mH"
      write(92,10) "    wwidth = par%wW"
      write(92,10) "    zwidth = par%wZ"
      write(92,10) "    awidth = 0"
      write(92,10) "    hwidth = par%wH"
      write(92,10) "  end subroutine reset"
c       write(92,10) "  end subroutine set_const"
      write(92,10)

! Write the sqme wrapper
! Again, assume that the out-spin index varies faster than the in-index

      write(92,10) "  subroutine scatter_diagonal_nonzero "//
     &     "(p, rho_in, rho_out, zero, n)"
      write(92,10) "    real(D), dimension(0:,:), intent(in) :: p"
      write(92,10) "    real(D), dimension(:,:), intent(in) :: rho_in"
      write(92,10) "    "//
     &     "real(D), dimension(:,:), intent(inout) :: rho_out"
      write(92,10) "    "//
     &     "integer, dimension(:,:,:,:), intent(inout) :: zero"
      write(92,10) "    integer, intent(in) :: n"
      write(92,10) "    integer :: hi, ho, h"
      write(92,10) "    real(D) :: sqme"
      write(92,10) "    h = 0"
      write(92,10) "    rho_out = 0"
      write(92,10) "    do hi=1, number_spin_states_in ()"
      write(92,10) "       do ho=1, number_spin_states_out ()"
      write(92,10) "          h = h + 1"
      write(92,10) "          if (n <= SAMPLE "//
     &     ".and. zero(hi,1,ho,1) <= REPEAT) then"
      write(92,10) "            sqme = sqme_pol (p, nhel(:,h))"
      write(92,10) "            if (sqme <= tiny (1._D)) "//
     &     "zero(hi,1,ho,1) = zero(hi,1,ho,1) + 1"
      write(92,10) "          else if (zero(hi,1,ho,1) < REPEAT) then"
      write(92,10) "            sqme = sqme_pol (p, nhel(:,h))"
      write(92,10) "          else"
      write(92,10) "            sqme = 0"
      write(92,10) "          end if"
      write(92,10) "          rho_out (ho,1) = rho_out (ho,1) + "//
     &     "sqme * rho_in (hi,1)"
      write(92,10) "       end do"
      write(92,10) "    end do"
      write(92,10) "  end subroutine scatter_diagonal_nonzero"
      write(92,10)
      write(92,10)

c  ! Write the sqme wrapper (old interface)
c        write(92,10) "  function sqme (p, h)"
c        write(92,10) "    real(D), dimension(0:,:), intent(in) :: p"
c        write(92,10) 
c       &     "    integer, dimension(:), intent(in), optional :: h"
c        write(92,10) "    real(D) :: sqme"
c        write(92,10) "    integer :: khel"
c        write(92,10) "    if (present(h)) then"
c        write(92,10) "       khel = 0"
c        do i=1, nexternal
c           select case(abs(iline(i)))
c           case(21:22)
c              write(92,12)
c       &           "       if (h(", i, ")==0) then"             ! photon/gluon
c              write(92,10)
c       &           "          sqme = 0;  return"
c              write(92,10)
c       &           "       else"
c              write(92,12)
c       &           "          khel = (h(", i, ")+1)/2 + 2*khel" ! fermion
c              write(92,10)
c       &           "       end if"
c           case(23:24)
c              write(92,12)        
c       &           "       khel = (h(", i, ")+1)   + 3*khel"    ! W/Z
c           case(25)                                             ! Higgs: hel=0
c           case default
c              write(92,12)
c       &           "       khel = (h(", i, ")+1)/2 + 2*khel"    ! fermion
c           end select
c        end do
c        write(92,10) "       khel = khel + 1"
c        write(92,10) "       sqme = sqme_mad (p,khel)"
c        write(92,10) "    else"
c        write(92,10) "       sqme = sqme_mad (p)"
c        write(92,10) "    end if"
c        write(92,10) "  end function sqme"
c        write(92,10)
c        write(92,10)


 10   format(6x,a)
 11   format(6x,a,i1)
 12   format(6x,a,i1,a)
 13   format(6x,a,i1,a,i3)
 22   format(6x,a,i2,a,i2,a)
 23   format(6x,a,i2,a,i9)
 44   format(6x,a,i4)
        
      end subroutine write_interface
